#Include "connect_engine.bi"
#include "fbgfx.bi"
using fb

screenres 640,480,32

dim shared as integer mx,my,btn,ox,oy,dx,dy

type chessMove
	x1 as integer
	x2 as integer
	y1 as integer
	y2 as integer
	t1 as integer
	t2 as integer
end type

dim shared as integer board(12,12) 'internal representation of board

dim shared as integer exitFlag     'exit program
dim shared as integer bx,by        'position top/left of board

dim shared as FB.Image ptr sImage
sImage = ImageCreate( 42, 42, 0 )  'save screen data

'THIS DETERMINES WHERE TO PLACE BOARD IN WINDOW
bx = 130
by = 30

'read board
for j as integer = 0 to 11
	for i as integer = 0 to 11
		read board(i,j)
	next i
next j

'12 images
dim shared as FB.Image ptr iPiece(12)

'allocate for 12 images
for i As integer = 0 to 11
	iPiece(i) = imagecreate(42,42,0)
next i

dim as string datum

'copy images from data statements to screen
for i as integer = 0 to 5   'for each piece
	for y as integer = 0 to 41  'for each row
		read datum
		for x as integer = 0 to 41  'for each column
			if mid(datum,x+1,1)="." then
				pset(x+i*42,y),rgb(255,0,255) 'transparent color
				pset(x+i*42+252,y),rgb(255,0,255)
			end if
			if mid(datum,x+1,1)="#" then
				pset(x+i*42,y),rgb(0,0,0)
				pset(x+i*42+252,y),rgb(0,0,0)
			end if
			if mid(datum,x+1,1)="*" then
				pset(x+i*42,y),rgb(120,120,180)
				pset(x+i*42+252,y),rgb(250,200,200)
			end if
		next x
	next y
next i
'sleep

'get set of 12 images
for i as integer = 0 to 11
	get (i*42,0)-(i*42+41,41), iPiece(i)
next i

sub update()
	screenlock()
	'drawBoard
	color rgb(255,255,255),rgb(100,255,100)
	cls
	dim as integer shade
	shade = 1
	for y as integer = 0 to 7
		shade = -shade
		for x as integer = 0 to 7
			if shade = -1 then
				line (bx+x*42,by+y*42)-(bx+x*42+41,by+y*42+41),rgb(252,206,156),bf
			else
				line (bx+x*42,by+y*42)-(bx+x*42+41,by+y*42+41),rgb(179,110,44),bf
			end if
			shade = -shade
		next x
	next y
	'border of board
	line (bx-1,by-1)-(bx+336,by+336),rgb(0,0,0),b

	'now draw image on square
	for y as integer = 0 to 7
		for x as integer = 0 to 7
			'put image onto square
			if board(x+2,y+2)<>7 and board(x+2,y+2)<>0 then
				if board(x+2,y+2)<0 then
					put (bx+x*42,by+y*42),iPiece(abs(board(x+2,y+2))-1),trans
				else
					put (bx+x*42,by+y*42),iPiece(abs(board(x+2,y+2))+5),trans
				end if
			end if
		next x
	next y

	screenunlock()
end sub

sub makeMove(cMove as chessMove)
	locate 1,1
	dim as integer choice  'number of selected piece
	dim as integer px1,py1,px2,py2,dx,dy  'moving data
	cMove.y1 = cMove.y1-1
	cMove.y2 = cMove.y2-1



	px1 = cMove.x1*42+bx   'screen pointer to chosen image
	py1 = cMove.y1*42+by
	px2 = cMove.x2*42+bx
	py2 = cMove.y2*42+by


	ox = px1
	oy = py1

	'make move on internal board
	choice = board(cMove.x1+2,cMove.y1+2)
	board(cMove.x2+2,cMove.y2+2) = choice
	board(cMove.x1+2,cMove.y1+2)=0  'erase data

	'convert to image ID of that number
	if choice<0 then
		choice = abs(choice)-1
	else
		choice = choice + 5
	end if


	line (px1,py1)-(px1+41,py1+41),point(px1+2,py1+2),bf 'clear
	for i as integer = 0 to 3
		line (px1+i,py1+i)-(px1+41-i,py1+41-i),rgb(0,0,244),b  'source
		line (px2+i,py2+i)-(px2+41-i,py2+41-i),rgb(0,255,0),b  'destination
	next i


	'compute direction of movement
	if px1>px2 then
		dx = -1
	else
		dx = 1
	end if
	if py1>py2 then
		dy = -1
	else
		dy = 1
	end if

	get (px1,py1)-(px1+41,py1+41),sImage
	put (px1,py1),iPiece(choice),trans
	ox = px1
	oy = py1

	while px1 <> px2 or py1 <> py2
		'update coordinates
		if px1<>px2 then
			px1 = px1+dx
		end if
		if py1<>py2 then
			py1 = py1+dy
		end if

		put (ox,oy),sImage,pset        'restore old back ground
		get (px1,py1)-(px1+41,py1+41),sImage 'save new back ground
		put (px1,py1),iPiece(choice),trans  'place on new back ground
		ox = px1
		oy = py1
		sleep 4

	wend
	'sleep
end sub

'convert string chess moves to numbers
function strMoveToNumMove(move as string) as chessMove
	dim as chessMove cm
	move = UCASE(move)
	cm.x1 = asc(mid(move,1,1))-65
	cm.y1 = val(mid(move,2,1))
	cm.x2 = asc(mid(move,3,1))-65
	cm.y2 = val(mid(move,4,1))
	return cm
end function

'convert chess move numbers to string format
function numMovetoStrMove(cm as chessMove) as string
	return chr(cm.x1+65)+str(cm.y1)+chr(cm.x2+65)+str(cm.y2)
end Function


update()
exitFlag = 0
dim as chessMove cMove
dim as string    move
Dim As String hod = Space(9999999)
hod = "position startpos moves"
locate 52,30
print "Wait loading engine!"
WriteEngineInfo("uci")
locate 52,30
print "Calculate position..."
move = ReadEngineInfo()
WriteEngineInfo("go depth 10")
move = ReadEngineInfo()


'***************  MAIN LOOP ************************
Do
	hod= hod & " " & move
	Next_:
	WriteEngineInfo(hod)
	WriteEngineInfo("go depth 10")
	If move  <> "err" Then
		'print move
		If Left(move,4) = "e1g1" Then
			cMove = strMoveToNumMove(Left(move,4))
			makeMove(cMove)
			cMove = strMoveToNumMove("h1f1")
			makeMove(cMove)
			update()
		elseIf Left(move,4) = "e8g8" Then
			cMove = strMoveToNumMove(Left(move,4))
			makeMove(cMove)
			cMove = strMoveToNumMove("h8f8")
			makeMove(cMove)
			update()
		ElseIf Left(move,4) = "e1c1" Then
			cMove = strMoveToNumMove(Left(move,4))
			makeMove(cMove)
			cMove = strMoveToNumMove("a1d1")
			makeMove(cMove)
			update()
		ElseIf Left(move,4) = "e8c8" Then
			cMove = strMoveToNumMove(Left(move,4))
			makeMove(cMove)
			cMove = strMoveToNumMove("a8d8")
			makeMove(cMove)
			update()
		Else
			cMove = strMoveToNumMove(Left(move,4))
			makeMove(cMove)
			update()
		EndIf
	Else
		Sleep(1000)
	endif
	move = ReadEngineInfo()
	If move  = "err" Then
		locate 52,30
		print "Error, try again   "
		GoTo Next_
	EndIf
	locate 52,30
	print move
	If Left(move,4) = "a1a1" Then
		locate 52,30
		print " << CHECK MATE >> "
		sleep
		Exit Do
	EndIf
	Sleep(1)
loop until move = "err" or multikey(&H01)


end


'***************************************************

' 1 = pawn, 2 = knight, 3 = bishop, 4 = rook, 5 = queen, 6 = king, 7 = border
' black pieces given negative value, sgn() returns -1 for black and +1 for white

'    0  1  2  3  4  5  6  7  8  9  10 11  <--- internal coordinates
'          A  B  C  D  E  F  G  H         <--- display coordinates
boardLayout:
data 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7 '0
data 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7 '1
data 7, 7, 2, 3, 4, 5, 6, 4, 3, 2, 7, 7 '2     8
data 7, 7, 1, 1, 1, 1, 1, 1, 1, 1, 7, 7 '3     7
data 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7, 7 '4     6
data 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7, 7 '5     5
data 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7, 7 '6     4
data 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7, 7 '7     3
data 7, 7,-1,-1,-1,-1,-1,-1,-1,-1, 7, 7 '8     2
data 7, 7,-2,-3,-4,-5,-6,-4,-3,-2, 7, 7 '9     1
data 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7 '10
data 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7 '11


Pieces:
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA "....................####.................."
DATA "...................#****#................."
DATA "..................#******#................"
DATA ".................#********#..............."
DATA ".................#********#..............."
DATA ".................#********#..............."
DATA ".................#********#..............."
DATA "..................#******#................"
DATA "...................#****#................."
DATA "...................######................."
DATA "..................#******#................"
DATA "................##********##.............."
DATA "...............#************#............."
DATA "..............#**************#............"
DATA "..............################............"
DATA ".................#********#..............."
DATA ".................#********#..............."
DATA ".................#********#..............."
DATA "................#**********#.............."
DATA "................#**********#.............."
DATA "...............#************#............."
DATA "..............#**************#............"
DATA ".............#****************#..........."
DATA "............#******************#.........."
DATA "............#******************#.........."
DATA "............####################.........."
DATA "...........#********************#........."
DATA "...........#********************#........."
DATA "...........######################........."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."

DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA "...........#####..######..#####..........."
DATA "...........#***#..#****#..#***#..........."
DATA "...........#***#..#****#..#***#..........."
DATA "...........#***#..#****#..#***#..........."
DATA "...........#***####****####***#..........."
DATA "...........#******************#..........."
DATA "...........#******************#..........."
DATA "...........#******************#..........."
DATA "...........#******************#..........."
DATA "...........####################..........."
DATA "............#****************#............"
DATA ".............################............."
DATA ".............#****#****#****#............."
DATA ".............#****#****#****#............."
DATA ".............################............."
DATA ".............#**#****#****#*#............."
DATA ".............#**#****#****#*#............."
DATA ".............################............."
DATA ".............#****#****#****#............."
DATA ".............#****#****#****#............."
DATA ".............################............."
DATA ".............#**#****#****#*#............."
DATA ".............#**#****#****#*#............."
DATA "............##################............"
DATA "...........#******************#..........."
DATA "..........#********************#.........."
DATA "..........#********************#.........."
DATA ".........#**********************#........."
DATA ".........########################........."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."

DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA "....................#....................."
DATA "...................##....................."
DATA "..................#**#...................."
DATA "..................#**###.................."
DATA ".................#******###..............."
DATA "................#**********#.............."
DATA "................#***********#............."
DATA "...............#**#*********#............."
DATA "..............#**##**********#............"
DATA ".............#**##.#*********#............"
DATA ".............#**###***********#..........."
DATA "............#*****************#..........."
DATA "............#*****************#..........."
DATA "...........#******************#..........."
DATA "...........#*******************#.........."
DATA "..........#******#####*********#.........."
DATA "..........#******#..#**********#.........."
DATA ".........#*******#..#**********#.........."
DATA ".........#******#..#***********#.........."
DATA "..........#****#..#***********#..........."
DATA "..........#####..#************#..........."
DATA "................#*************#..........."
DATA "...............#*************#............"
DATA "...............#*************#............"
DATA "..............#***************#..........."
DATA "..............#***************#..........."
DATA ".............#*****************#.........."
DATA ".............#******************#........."
DATA "............#*******************#........."
DATA "............######################........"
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."

DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".....................##..................."
DATA "....................#**#.................."
DATA "...................#****#................."
DATA "..................#******#................"
DATA ".................#********#..............."
DATA "................#**********#.............."
DATA "...............#************#............."
DATA "...............#************#............."
DATA "..............##************##............"
DATA "..............#**************#............"
DATA "..............#**************#............"
DATA "..............#******##******#............"
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA ".............#****########****#..........."
DATA ".............#****########****#..........."
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA ".............#*******##*******#..........."
DATA "..............#******##******#............"
DATA "..............#******##******#............"
DATA "...............#************#............."
DATA "...............#************#............."
DATA "...............##############............."
DATA "...............##**********##............."
DATA "................############.............."
DATA "..............##************##............"
DATA "............##*****######*****##.........."
DATA "...........#*****##......##*****#........."
DATA "...........######..........######........."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."

DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA ".....................#...................."
DATA "....................#*#..................."
DATA "...................#***#.................."
DATA "..................#*****#................."
DATA "..................#*****#................."
DATA "..................#*****#................."
DATA "............#.....#*****#.....#..........."
DATA "...........#*#.....#***#.....#*#.........."
DATA "..........#***#....#***#....#***#........."
DATA "..........#***#....#***#....#***#........."
DATA "...........#*#.....#***#.....#*#.........."
DATA "...........#*#.....#***#.....#*#.........."
DATA "..........#***#...#*****#...#***#........."
DATA "..........#***#..#*******#..#***#........."
DATA "..........#***#..#*******#..#***#........."
DATA ".....##...#***#...#*****#...#***#...##...."
DATA ".....#*#..#***#...#*****#...#***#..#*#...."
DATA ".....#**#.#***#...#*****#...#***#.#**#...."
DATA ".....#**#.#***#...#*****#...#***#.#**#...."
DATA "......#*#.#***#...#*****#...#***#.#*#....."
DATA "......#**##***#...#*****#...#***##**#....."
DATA "......#**#*****#.#*******#.#*****#**#....."
DATA ".......#*******##*********##*******#......"
DATA ".......#***************************#......"
DATA "........#*************************#......."
DATA "........###########################......."
DATA "........#*************************#......."
DATA "........#*************************#......."
DATA "........#*************************#......."
DATA "........#*************************#......."
DATA "........#*************************#......."
DATA "........###########################......."
DATA ".......#***************************#......"
DATA ".......#***************************#......"
DATA ".......#############################......"
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."

DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
DATA "....................###..................."
DATA "....................#*#..................."
DATA "..................###*###................."
DATA "..................#*****#................."
DATA "..................###*###................."
DATA "....................#*#..................."
DATA "....................#*#..................."
DATA "...................#####.................."
DATA "..................#*****#................."
DATA "..................#*****#................."
DATA "..................#*****#................."
DATA "...................#***#.................."
DATA "......#########.....#*#.....#########....."
DATA ".....#.........######*######.........#...."
DATA ".....#..............#*#..............#...."
DATA ".....#....####......#*#......####....#...."
DATA ".....#...#****###...#*#...###****#...#...."
DATA ".....#.##********##.#*#.##********##.#...."
DATA ".....#.#***********##*##***********#.#...."
DATA ".....#.#************#*#************#.#...."
DATA ".....#.#*****####***#*#***####*****#.#...."
DATA ".....#.#****#****##*#*#*##****#****#.#...."
DATA "......#*****#******##*##******#*****#....."
DATA ".......#****#*******#*#*******#****#......"
DATA ".......#****#*******#*#*******#****#......"
DATA "........#****#******#*#******#****#......."
DATA "........#****#******#*#******#****#......."
DATA ".........#****#*****#*#*****#****#........"
DATA ".........#*****#****#*#****#*****#........"
DATA "..........#*****#***#*#***#*****#........."
DATA "..........#######################........."
DATA "..........#*********************#........."
DATA "..........#######################........."
DATA ".........##*********************##........"
DATA "........##***********************##......."
DATA "........###########################......."
DATA ".........................................."
DATA ".........................................."
DATA ".........................................."
